# Buffered pipes

Attempt to generalize the “feeder” part of a `Channel`: an object which can be read from and closed, but is reading from a buffer fed by another thread. The read operations are blocking and can have a timeout set.

class paramiko.buffered_pipe.BufferedPipe

  A buffer that obeys normal read (with timeout) & close semantics for a file or socket, but is fed data from another thread. This is used by `Channel`.

  __init__()
  __len__()

    Return the number of bytes buffered.

    Returns:

      number (`int`) of bytes buffered

  __weakref__

    list of weak references to the object (if defined)

  close()

    Close this pipe object. Future calls to `read` after the buffer has been emptied will return immediately with an empty string.

  empty()

    Clear out the buffer and return all data that was in it.

    Returns:

      any data that was in the buffer prior to clearing it out, as a `str`

  feed(data)

    Feed new data into this pipe. This method is assumed to be called from a separate thread, so synchronization is done.

    Parameters:

      data – the data to add, as a `str` or `bytes`

  read(nbytes, timeout=None)

    Read data from the pipe. The return value is a string representing the data received. The maximum amount of data to be received at once is specified by `nbytes`. If a string of length zero is returned, the pipe has been closed.

    The optional `timeout` argument can be a nonnegative float expressing seconds, or `None` for no timeout. If a float is given, a `PipeTimeout` will be raised if the timeout period value has elapsed before any data arrives.

    Parameters:

      - nbytes (int) – maximum number of bytes to read

      - timeout (float) – maximum seconds to wait (or `None`, the default, to wait forever)

    Returns:

      the read data, as a `str` or `bytes`

    Raises:

      `PipeTimeout` – if a timeout was specified and no data was ready before that timeout

  read_ready()

    Returns true if data is buffered and ready to be read from this feeder. A `False` result does not mean that the feeder has closed; it means you may need to wait before more data arrives.

    Returns:

      `True` if a `read` call would immediately return at least one byte; `False` otherwise.

  set_event(event)

    Set an event on this buffer. When data is ready to be read (or the buffer has been closed), the event will be set. When no data is ready, the event will be cleared.

    Parameters:

      event (threading.Event) – the event to set/clear

exception paramiko.buffered_pipe.PipeTimeout

  Indicates that a timeout was reached on a read from a `BufferedPipe`.

  __weakref__

    list of weak references to the object (if defined)